HDU 1069 Monkey and Banana 对比优先权的设置和排序问题(解析)

Monkey and Banana
Time Limit:1000MS    Memory Limit:32768KB    64bit IO Format:%I64d & %I64u

Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, 
and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana
 by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid 
with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions
 of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a
 tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both 
strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey 
to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.


Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
 

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height
 of the tallest possible tower in the format "Case case: maximum height = height".
 

Sample Input

     
     
1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
 

Sample Output

     
     
Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
思路:一个立方体变成三个,按照底面两条边从小到大排序,求最长上升子序列。
>>AC代码:
>主要是优先权的设置问题
#include<iostream>
#include<string>
#include<algorithm>
#include<vector>
using namespace std;
int n,b[3],dp[101];
struct pd{
 int a,b,c;
 pd(int a1,int a2,int a3):a(a1),b(a2),c(a3){};
 bool operator<(const pd aa)const{
	 return (a>aa.a||(a==aa.a&&b>aa.b));}
};
vector<pd>pp;
int main(){
	int k=0;
		while(cin>>n&&n){
		memset(dp,0,sizeof(dp));
		pp.clear();
		for(int i=0;i<n;i++){
			for(int j=0;j<3;j++){
				scanf("%d",b+j);
			}
			sort(b,b+3);
			pp.push_back(pd(b[0],b[1],b[2]));
				pp.push_back(pd(b[0],b[2],b[1]));
					pp.push_back(pd(b[1],b[2],b[0]));
		}
		sort(pp.begin(),pp.end());
		int ans=0;
		for(int i=0;i<pp.size();i++){
		dp[i]=pp[i].c;
//有可能存在所有的j都小于i,即ans只是一个pp的值,所以要不断更新dp[i]=pp[i].c,当只有一个符合时,单独的dp[i]可能是最大的,即与ans比较

			for(int j=0;j<i;j++){
				if(pp[j].a>pp[i].a&&pp[j].b>pp[i].b){
					dp[i]=max(dp[i], dp[j]+pp[i].c);}
			}
				
				
				ans=max(ans, dp[i]);
			
		}
		printf("Case %d: maximum height = %d\n",++k,ans);
		
	}
	return 0;
}


 
    
  
 
 
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
对于HDU4546问题,还可以使用优先队列(Priority Queue)来解决。以下是使用优先队列的解法思路: 1. 首先,将数组a进行排序,以便后续处理。 2. 创建一个优先队列(最小堆),用于存储组合之和的候选值。 3. 初始化优先队列,将初始情况(即前0个数的组合之和)加入队列。 4. 开始从1到n遍历数组a的元素,对于每个元素a[i],将当前队列中的所有候选值取出,分别加上a[i],然后再将加和的结果作为新的候选值加入队列。 5. 重复步骤4直到遍历完所有元素。 6. 当队列的大小超过k时,将队列中的最小值弹出。 7. 最后,队列中的所有候选值之和即为前k小的组合之和。 以下是使用优先队列解决HDU4546问题的代码示例: ```cpp #include <iostream> #include <vector> #include <queue> #include <functional> using namespace std; int main() { int n, k; cin >> n >> k; vector<int> a(n); for (int i = 0; i < n; i++) { cin >> a[i]; } sort(a.begin(), a.end()); // 对数组a进行排序 priority_queue<long long, vector<long long>, greater<long long>> pq; // 最小堆 pq.push(0); // 初始情况,前0个数的组合之和为0 for (int i = 0; i < n; i++) { long long num = pq.top(); // 取出当前队列中的最小值 pq.pop(); for (int j = i + 1; j <= n; j++) { pq.push(num + a[i]); // 将所有加和结果作为新的候选值加入队列 num += a[i]; } if (pq.size() > k) { pq.pop(); // 当队列大小超过k时,弹出最小值 } } long long sum = 0; while (!pq.empty()) { sum += pq.top(); // 求队列中所有候选值之和 pq.pop(); } cout << sum << endl; return 0; } ``` 使用优先队列的方法可以有效地找到前k小的组合之和,时间复杂度为O(nklog(k))。希望这个解法对你有所帮助!

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值